# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from typing import Any, Dict, List, Optional, Tuple, Union

from pydantic import Field, StrictFloat, StrictInt, StrictStr, validate_call

try:
  from typing import Annotated
except ImportError:
  from typing_extensions import Annotated

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.models.coupon_external import CouponExternal
from getopenpay.models.coupon_query_params import CouponQueryParams
from getopenpay.models.create_coupon_request import CreateCouponRequest
from getopenpay.models.list_response_coupon_external import ListResponseCouponExternal
from getopenpay.models.update_coupon_request import UpdateCouponRequest
from getopenpay.rest import RESTResponseType
from pydantic import Field, StrictStr
from typing_extensions import Annotated


class CouponsApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_call
  def create_coupon(
    self,
    create_coupon_request: CreateCouponRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CouponExternal:
    """Create Coupon


        :param create_coupon_request: (required)
        :type create_coupon_request: CreateCouponRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_coupon_serialize(
      create_coupon_request=create_coupon_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def create_coupon_with_http_info(
    self,
    create_coupon_request: CreateCouponRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CouponExternal]:
    """Create Coupon


        :param create_coupon_request: (required)
        :type create_coupon_request: CreateCouponRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_coupon_serialize(
      create_coupon_request=create_coupon_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def create_coupon_without_preload_content(
    self,
    create_coupon_request: CreateCouponRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Create Coupon


        :param create_coupon_request: (required)
        :type create_coupon_request: CreateCouponRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_coupon_serialize(
      create_coupon_request=create_coupon_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _create_coupon_serialize(
    self,
    create_coupon_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if create_coupon_request is not None:
      _body_params = create_coupon_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/coupons/',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def delete_coupon(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> None:
    """Delete Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_coupon_serialize(
      coupon_id=coupon_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {}
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def delete_coupon_with_http_info(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[None]:
    """Delete Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_coupon_serialize(
      coupon_id=coupon_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {}
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def delete_coupon_without_preload_content(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Delete Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_coupon_serialize(
      coupon_id=coupon_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {}
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _delete_coupon_serialize(
    self,
    coupon_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if coupon_id is not None:
      _path_params['coupon_id'] = coupon_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='DELETE',
      resource_path='/coupons/{coupon_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_coupon(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CouponExternal:
    """Get Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_coupon_serialize(
      coupon_id=coupon_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_coupon_with_http_info(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CouponExternal]:
    """Get Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_coupon_serialize(
      coupon_id=coupon_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_coupon_without_preload_content(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_coupon_serialize(
      coupon_id=coupon_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_coupon_serialize(
    self,
    coupon_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if coupon_id is not None:
      _path_params['coupon_id'] = coupon_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/coupons/{coupon_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def list_coupons(
    self,
    coupon_query_params: CouponQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ListResponseCouponExternal:
    """List Coupons


        :param coupon_query_params: (required)
        :type coupon_query_params: CouponQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_coupons_serialize(
      coupon_query_params=coupon_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def list_coupons_with_http_info(
    self,
    coupon_query_params: CouponQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ListResponseCouponExternal]:
    """List Coupons


        :param coupon_query_params: (required)
        :type coupon_query_params: CouponQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_coupons_serialize(
      coupon_query_params=coupon_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def list_coupons_without_preload_content(
    self,
    coupon_query_params: CouponQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """List Coupons


        :param coupon_query_params: (required)
        :type coupon_query_params: CouponQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_coupons_serialize(
      coupon_query_params=coupon_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _list_coupons_serialize(
    self,
    coupon_query_params,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if coupon_query_params is not None:
      _body_params = coupon_query_params

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/coupons/list',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def update_coupon(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    update_coupon_request: UpdateCouponRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CouponExternal:
    """Update Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param update_coupon_request: (required)
        :type update_coupon_request: UpdateCouponRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_coupon_serialize(
      coupon_id=coupon_id,
      update_coupon_request=update_coupon_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def update_coupon_with_http_info(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    update_coupon_request: UpdateCouponRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CouponExternal]:
    """Update Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param update_coupon_request: (required)
        :type update_coupon_request: UpdateCouponRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_coupon_serialize(
      coupon_id=coupon_id,
      update_coupon_request=update_coupon_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def update_coupon_without_preload_content(
    self,
    coupon_id: Annotated[StrictStr,
                         Field(description='Unique identifier of the Coupon.')],
    update_coupon_request: UpdateCouponRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Update Coupon


        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param update_coupon_request: (required)
        :type update_coupon_request: UpdateCouponRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_coupon_serialize(
      coupon_id=coupon_id,
      update_coupon_request=update_coupon_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _update_coupon_serialize(
    self,
    coupon_id,
    update_coupon_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if coupon_id is not None:
      _path_params['coupon_id'] = coupon_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if update_coupon_request is not None:
      _body_params = update_coupon_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='PUT',
      resource_path='/coupons/{coupon_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )
