# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from typing import Any, Dict, List, Optional, Tuple, Union

from pydantic import Field, StrictFloat, StrictInt, StrictStr, validate_call

try:
  from typing import Annotated
except ImportError:
  from typing_extensions import Annotated

from typing import List, Optional

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.models.active_sub_response import ActiveSubResponse
from getopenpay.models.create_customer_balance_transaction_request import (
  CreateCustomerBalanceTransactionRequest
)
from getopenpay.models.create_customer_request import CreateCustomerRequest
from getopenpay.models.customer_balance_transaction_external import (
  CustomerBalanceTransactionExternal
)
from getopenpay.models.customer_external import CustomerExternal
from getopenpay.models.customer_payment_method_query_params import CustomerPaymentMethodQueryParams
from getopenpay.models.customer_query_params import CustomerQueryParams
from getopenpay.models.list_active_sub_params import ListActiveSubParams
from getopenpay.models.list_response_customer_external import ListResponseCustomerExternal
from getopenpay.models.list_response_payment_method_external import (
  ListResponsePaymentMethodExternal
)
from getopenpay.models.search_customer_request import SearchCustomerRequest
from getopenpay.models.update_customer_request import UpdateCustomerRequest
from getopenpay.rest import RESTResponseType
from pydantic import Field, StrictStr
from typing_extensions import Annotated


class CustomersApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_call
  def create_customer(
    self,
    create_customer_request: CreateCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CustomerExternal:
    """Create Customer


        :param create_customer_request: (required)
        :type create_customer_request: CreateCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_customer_serialize(
      create_customer_request=create_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def create_customer_with_http_info(
    self,
    create_customer_request: CreateCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CustomerExternal]:
    """Create Customer


        :param create_customer_request: (required)
        :type create_customer_request: CreateCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_customer_serialize(
      create_customer_request=create_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def create_customer_without_preload_content(
    self,
    create_customer_request: CreateCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Create Customer


        :param create_customer_request: (required)
        :type create_customer_request: CreateCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_customer_serialize(
      create_customer_request=create_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _create_customer_serialize(
    self,
    create_customer_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if create_customer_request is not None:
      _body_params = create_customer_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/customers/',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def create_customer_balance_transaction(
    self,
    customer_id: StrictStr,
    create_customer_balance_transaction_request: CreateCustomerBalanceTransactionRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CustomerBalanceTransactionExternal:
    """Create Customer Balance Transaction

        Each customer has a Balance value, which denotes a debit or credit that's automatically applied to their next invoice upon finalization. Creates an immutable transaction that updates the customer's credit balance.

        :param customer_id: (required)
        :type customer_id: str
        :param create_customer_balance_transaction_request: (required)
        :type create_customer_balance_transaction_request: CreateCustomerBalanceTransactionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_customer_balance_transaction_serialize(
      customer_id=customer_id,
      create_customer_balance_transaction_request=create_customer_balance_transaction_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerBalanceTransactionExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def create_customer_balance_transaction_with_http_info(
    self,
    customer_id: StrictStr,
    create_customer_balance_transaction_request: CreateCustomerBalanceTransactionRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CustomerBalanceTransactionExternal]:
    """Create Customer Balance Transaction

        Each customer has a Balance value, which denotes a debit or credit that's automatically applied to their next invoice upon finalization. Creates an immutable transaction that updates the customer's credit balance.

        :param customer_id: (required)
        :type customer_id: str
        :param create_customer_balance_transaction_request: (required)
        :type create_customer_balance_transaction_request: CreateCustomerBalanceTransactionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_customer_balance_transaction_serialize(
      customer_id=customer_id,
      create_customer_balance_transaction_request=create_customer_balance_transaction_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerBalanceTransactionExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def create_customer_balance_transaction_without_preload_content(
    self,
    customer_id: StrictStr,
    create_customer_balance_transaction_request: CreateCustomerBalanceTransactionRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Create Customer Balance Transaction

        Each customer has a Balance value, which denotes a debit or credit that's automatically applied to their next invoice upon finalization. Creates an immutable transaction that updates the customer's credit balance.

        :param customer_id: (required)
        :type customer_id: str
        :param create_customer_balance_transaction_request: (required)
        :type create_customer_balance_transaction_request: CreateCustomerBalanceTransactionRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_customer_balance_transaction_serialize(
      customer_id=customer_id,
      create_customer_balance_transaction_request=create_customer_balance_transaction_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerBalanceTransactionExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _create_customer_balance_transaction_serialize(
    self,
    customer_id,
    create_customer_balance_transaction_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_id is not None:
      _path_params['customer_id'] = customer_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if create_customer_balance_transaction_request is not None:
      _body_params = create_customer_balance_transaction_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/customers/{customer_id}/balance-transactions',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def delete_customer_discount(
    self,
    customer_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CustomerExternal:
    """Delete Customer Discount


        :param customer_id: (required)
        :type customer_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_customer_discount_serialize(
      customer_id=customer_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def delete_customer_discount_with_http_info(
    self,
    customer_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CustomerExternal]:
    """Delete Customer Discount


        :param customer_id: (required)
        :type customer_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_customer_discount_serialize(
      customer_id=customer_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def delete_customer_discount_without_preload_content(
    self,
    customer_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Delete Customer Discount


        :param customer_id: (required)
        :type customer_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_customer_discount_serialize(
      customer_id=customer_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _delete_customer_discount_serialize(
    self,
    customer_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_id is not None:
      _path_params['customer_id'] = customer_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='DELETE',
      resource_path='/customers/{customer_id}/discount',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_customer(
    self,
    customer_id: StrictStr,
    expand: Optional[List[StrictStr]] = None,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CustomerExternal:
    """Get Customer


        :param customer_id: (required)
        :type customer_id: str
        :param expand:
        :type expand: List[str]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_serialize(
      customer_id=customer_id,
      expand=expand,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_customer_with_http_info(
    self,
    customer_id: StrictStr,
    expand: Optional[List[StrictStr]] = None,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CustomerExternal]:
    """Get Customer


        :param customer_id: (required)
        :type customer_id: str
        :param expand:
        :type expand: List[str]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_serialize(
      customer_id=customer_id,
      expand=expand,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_customer_without_preload_content(
    self,
    customer_id: StrictStr,
    expand: Optional[List[StrictStr]] = None,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Customer


        :param customer_id: (required)
        :type customer_id: str
        :param expand:
        :type expand: List[str]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_serialize(
      customer_id=customer_id,
      expand=expand,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_customer_serialize(
    self,
    customer_id,
    expand,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {
      'expand': 'multi',
    }

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_id is not None:
      _path_params['customer_id'] = customer_id
    # process the query parameters
    if expand is not None:

      _query_params.append(('expand', expand))

    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/customers/{customer_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_customer_balance_transaction(
    self,
    customer_id: StrictStr,
    transaction_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CustomerBalanceTransactionExternal:
    """Get Customer Balance Transaction


        :param customer_id: (required)
        :type customer_id: str
        :param transaction_id: (required)
        :type transaction_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_balance_transaction_serialize(
      customer_id=customer_id,
      transaction_id=transaction_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerBalanceTransactionExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_customer_balance_transaction_with_http_info(
    self,
    customer_id: StrictStr,
    transaction_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CustomerBalanceTransactionExternal]:
    """Get Customer Balance Transaction


        :param customer_id: (required)
        :type customer_id: str
        :param transaction_id: (required)
        :type transaction_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_balance_transaction_serialize(
      customer_id=customer_id,
      transaction_id=transaction_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerBalanceTransactionExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_customer_balance_transaction_without_preload_content(
    self,
    customer_id: StrictStr,
    transaction_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Customer Balance Transaction


        :param customer_id: (required)
        :type customer_id: str
        :param transaction_id: (required)
        :type transaction_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_balance_transaction_serialize(
      customer_id=customer_id,
      transaction_id=transaction_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'CustomerBalanceTransactionExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_customer_balance_transaction_serialize(
    self,
    customer_id,
    transaction_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_id is not None:
      _path_params['customer_id'] = customer_id
    if transaction_id is not None:
      _path_params['transaction_id'] = transaction_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/customers/{customer_id}/balance-transactions/{transaction_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_customer_balance_transactions(
    self,
    customer_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> List[CustomerBalanceTransactionExternal]:
    """Get Customer Balance Transactions


        :param customer_id: (required)
        :type customer_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_balance_transactions_serialize(
      customer_id=customer_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'List[CustomerBalanceTransactionExternal]',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_customer_balance_transactions_with_http_info(
    self,
    customer_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[List[CustomerBalanceTransactionExternal]]:
    """Get Customer Balance Transactions


        :param customer_id: (required)
        :type customer_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_balance_transactions_serialize(
      customer_id=customer_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'List[CustomerBalanceTransactionExternal]',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_customer_balance_transactions_without_preload_content(
    self,
    customer_id: StrictStr,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Customer Balance Transactions


        :param customer_id: (required)
        :type customer_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_customer_balance_transactions_serialize(
      customer_id=customer_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'List[CustomerBalanceTransactionExternal]',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_customer_balance_transactions_serialize(
    self,
    customer_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_id is not None:
      _path_params['customer_id'] = customer_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/customers/{customer_id}/balance-transactions',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def list_customer_payment_methods(
    self,
    customer_id: Annotated[StrictStr,
                           Field(description='Unique Identifier of the customer.')],
    customer_payment_method_query_params: CustomerPaymentMethodQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ListResponsePaymentMethodExternal:
    """List Customer Payment Methods

        Retrieves payment methods for a given customer. Can optionally filter by payment provider type.

        :param customer_id: Unique Identifier of the customer. (required)
        :type customer_id: str
        :param customer_payment_method_query_params: (required)
        :type customer_payment_method_query_params: CustomerPaymentMethodQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_customer_payment_methods_serialize(
      customer_id=customer_id,
      customer_payment_method_query_params=customer_payment_method_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def list_customer_payment_methods_with_http_info(
    self,
    customer_id: Annotated[StrictStr,
                           Field(description='Unique Identifier of the customer.')],
    customer_payment_method_query_params: CustomerPaymentMethodQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ListResponsePaymentMethodExternal]:
    """List Customer Payment Methods

        Retrieves payment methods for a given customer. Can optionally filter by payment provider type.

        :param customer_id: Unique Identifier of the customer. (required)
        :type customer_id: str
        :param customer_payment_method_query_params: (required)
        :type customer_payment_method_query_params: CustomerPaymentMethodQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_customer_payment_methods_serialize(
      customer_id=customer_id,
      customer_payment_method_query_params=customer_payment_method_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def list_customer_payment_methods_without_preload_content(
    self,
    customer_id: Annotated[StrictStr,
                           Field(description='Unique Identifier of the customer.')],
    customer_payment_method_query_params: CustomerPaymentMethodQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """List Customer Payment Methods

        Retrieves payment methods for a given customer. Can optionally filter by payment provider type.

        :param customer_id: Unique Identifier of the customer. (required)
        :type customer_id: str
        :param customer_payment_method_query_params: (required)
        :type customer_payment_method_query_params: CustomerPaymentMethodQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_customer_payment_methods_serialize(
      customer_id=customer_id,
      customer_payment_method_query_params=customer_payment_method_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _list_customer_payment_methods_serialize(
    self,
    customer_id,
    customer_payment_method_query_params,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_id is not None:
      _path_params['customer_id'] = customer_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if customer_payment_method_query_params is not None:
      _body_params = customer_payment_method_query_params

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/customers/{customer_id}/payment-methods',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def list_customers(
    self,
    customer_query_params: CustomerQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ListResponseCustomerExternal:
    """List Customers


        :param customer_query_params: (required)
        :type customer_query_params: CustomerQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_customers_serialize(
      customer_query_params=customer_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def list_customers_with_http_info(
    self,
    customer_query_params: CustomerQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ListResponseCustomerExternal]:
    """List Customers


        :param customer_query_params: (required)
        :type customer_query_params: CustomerQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_customers_serialize(
      customer_query_params=customer_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def list_customers_without_preload_content(
    self,
    customer_query_params: CustomerQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """List Customers


        :param customer_query_params: (required)
        :type customer_query_params: CustomerQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_customers_serialize(
      customer_query_params=customer_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _list_customers_serialize(
    self,
    customer_query_params,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if customer_query_params is not None:
      _body_params = customer_query_params

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/customers/list',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def list_valid_subscriptions(
    self,
    customer_id: Annotated[StrictStr,
                           Field(description='Unique Identifier of the customer.')],
    list_active_sub_params: ListActiveSubParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ActiveSubResponse:
    """List Valid Subscriptions

        Lists valid subscriptions for given product_id or price_id. All 'active' or 'trialing' subscriptions are considered to be valid.

        :param customer_id: Unique Identifier of the customer. (required)
        :type customer_id: str
        :param list_active_sub_params: (required)
        :type list_active_sub_params: ListActiveSubParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_valid_subscriptions_serialize(
      customer_id=customer_id,
      list_active_sub_params=list_active_sub_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ActiveSubResponse',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def list_valid_subscriptions_with_http_info(
    self,
    customer_id: Annotated[StrictStr,
                           Field(description='Unique Identifier of the customer.')],
    list_active_sub_params: ListActiveSubParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ActiveSubResponse]:
    """List Valid Subscriptions

        Lists valid subscriptions for given product_id or price_id. All 'active' or 'trialing' subscriptions are considered to be valid.

        :param customer_id: Unique Identifier of the customer. (required)
        :type customer_id: str
        :param list_active_sub_params: (required)
        :type list_active_sub_params: ListActiveSubParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_valid_subscriptions_serialize(
      customer_id=customer_id,
      list_active_sub_params=list_active_sub_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ActiveSubResponse',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def list_valid_subscriptions_without_preload_content(
    self,
    customer_id: Annotated[StrictStr,
                           Field(description='Unique Identifier of the customer.')],
    list_active_sub_params: ListActiveSubParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """List Valid Subscriptions

        Lists valid subscriptions for given product_id or price_id. All 'active' or 'trialing' subscriptions are considered to be valid.

        :param customer_id: Unique Identifier of the customer. (required)
        :type customer_id: str
        :param list_active_sub_params: (required)
        :type list_active_sub_params: ListActiveSubParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_valid_subscriptions_serialize(
      customer_id=customer_id,
      list_active_sub_params=list_active_sub_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ActiveSubResponse',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _list_valid_subscriptions_serialize(
    self,
    customer_id,
    list_active_sub_params,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_id is not None:
      _path_params['customer_id'] = customer_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if list_active_sub_params is not None:
      _body_params = list_active_sub_params

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/customers{customer_id}/list_valid_subscriptions',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def search_customers(
    self,
    search_customer_request: SearchCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ListResponseCustomerExternal:
    """Search Customers


        :param search_customer_request: (required)
        :type search_customer_request: SearchCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._search_customers_serialize(
      search_customer_request=search_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def search_customers_with_http_info(
    self,
    search_customer_request: SearchCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ListResponseCustomerExternal]:
    """Search Customers


        :param search_customer_request: (required)
        :type search_customer_request: SearchCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._search_customers_serialize(
      search_customer_request=search_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def search_customers_without_preload_content(
    self,
    search_customer_request: SearchCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Search Customers


        :param search_customer_request: (required)
        :type search_customer_request: SearchCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._search_customers_serialize(
      search_customer_request=search_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponseCustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _search_customers_serialize(
    self,
    search_customer_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if search_customer_request is not None:
      _body_params = search_customer_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/customers/search',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def update_customer(
    self,
    customer_external_id: StrictStr,
    update_customer_request: UpdateCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> CustomerExternal:
    """Update Customer


        :param customer_external_id: (required)
        :type customer_external_id: str
        :param update_customer_request: (required)
        :type update_customer_request: UpdateCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_customer_serialize(
      customer_external_id=customer_external_id,
      update_customer_request=update_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def update_customer_with_http_info(
    self,
    customer_external_id: StrictStr,
    update_customer_request: UpdateCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[CustomerExternal]:
    """Update Customer


        :param customer_external_id: (required)
        :type customer_external_id: str
        :param update_customer_request: (required)
        :type update_customer_request: UpdateCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_customer_serialize(
      customer_external_id=customer_external_id,
      update_customer_request=update_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def update_customer_without_preload_content(
    self,
    customer_external_id: StrictStr,
    update_customer_request: UpdateCustomerRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Update Customer


        :param customer_external_id: (required)
        :type customer_external_id: str
        :param update_customer_request: (required)
        :type update_customer_request: UpdateCustomerRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_customer_serialize(
      customer_external_id=customer_external_id,
      update_customer_request=update_customer_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'CustomerExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _update_customer_serialize(
    self,
    customer_external_id,
    update_customer_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if customer_external_id is not None:
      _path_params['customer_external_id'] = customer_external_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if update_customer_request is not None:
      _body_params = update_customer_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='PUT',
      resource_path='/customers/{customer_external_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )
