# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from typing import Any, Dict, List, Optional, Tuple, Union

from pydantic import Field, StrictFloat, StrictInt, StrictStr, validate_call

try:
  from typing import Annotated
except ImportError:
  from typing_extensions import Annotated

from typing import Optional

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.models.attach_payment_method_request import AttachPaymentMethodRequest
from getopenpay.models.payment_method_external import PaymentMethodExternal
from getopenpay.rest import RESTResponseType
from pydantic import Field, StrictInt, StrictStr
from typing_extensions import Annotated


class PaymentMethodsApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_call
  def attach_payment_method(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    attach_payment_method_request: AttachPaymentMethodRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PaymentMethodExternal:
    """Attach Payment Method

        Attaches the payment_method to a customer. A Payment_method must be attached to a customer before it can be used for payment. Once attached to a customer, it can not be reattached to a different customer.

        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param attach_payment_method_request: (required)
        :type attach_payment_method_request: AttachPaymentMethodRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._attach_payment_method_serialize(
      payment_method_id=payment_method_id,
      attach_payment_method_request=attach_payment_method_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def attach_payment_method_with_http_info(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    attach_payment_method_request: AttachPaymentMethodRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PaymentMethodExternal]:
    """Attach Payment Method

        Attaches the payment_method to a customer. A Payment_method must be attached to a customer before it can be used for payment. Once attached to a customer, it can not be reattached to a different customer.

        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param attach_payment_method_request: (required)
        :type attach_payment_method_request: AttachPaymentMethodRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._attach_payment_method_serialize(
      payment_method_id=payment_method_id,
      attach_payment_method_request=attach_payment_method_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def attach_payment_method_without_preload_content(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    attach_payment_method_request: AttachPaymentMethodRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Attach Payment Method

        Attaches the payment_method to a customer. A Payment_method must be attached to a customer before it can be used for payment. Once attached to a customer, it can not be reattached to a different customer.

        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param attach_payment_method_request: (required)
        :type attach_payment_method_request: AttachPaymentMethodRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._attach_payment_method_serialize(
      payment_method_id=payment_method_id,
      attach_payment_method_request=attach_payment_method_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _attach_payment_method_serialize(
    self,
    payment_method_id,
    attach_payment_method_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if payment_method_id is not None:
      _path_params['payment_method_id'] = payment_method_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if attach_payment_method_request is not None:
      _body_params = attach_payment_method_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/payment-methods/{payment_method_id}/attach',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def authorize_credit_card(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    authorization_amount_atom: Annotated[
      Optional[StrictInt],
      Field(description='Amount to authorize in the smallest currency unit (e.g., cents).')] = None,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PaymentMethodExternal:
    """Authorize Credit Card


        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param authorization_amount_atom: Amount to authorize in the smallest currency unit (e.g., cents).
        :type authorization_amount_atom: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._authorize_credit_card_serialize(
      payment_method_id=payment_method_id,
      authorization_amount_atom=authorization_amount_atom,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def authorize_credit_card_with_http_info(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    authorization_amount_atom: Annotated[
      Optional[StrictInt],
      Field(description='Amount to authorize in the smallest currency unit (e.g., cents).')] = None,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PaymentMethodExternal]:
    """Authorize Credit Card


        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param authorization_amount_atom: Amount to authorize in the smallest currency unit (e.g., cents).
        :type authorization_amount_atom: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._authorize_credit_card_serialize(
      payment_method_id=payment_method_id,
      authorization_amount_atom=authorization_amount_atom,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def authorize_credit_card_without_preload_content(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    authorization_amount_atom: Annotated[
      Optional[StrictInt],
      Field(description='Amount to authorize in the smallest currency unit (e.g., cents).')] = None,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Authorize Credit Card


        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param authorization_amount_atom: Amount to authorize in the smallest currency unit (e.g., cents).
        :type authorization_amount_atom: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._authorize_credit_card_serialize(
      payment_method_id=payment_method_id,
      authorization_amount_atom=authorization_amount_atom,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _authorize_credit_card_serialize(
    self,
    payment_method_id,
    authorization_amount_atom,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if payment_method_id is not None:
      _path_params['payment_method_id'] = payment_method_id
    # process the query parameters
    if authorization_amount_atom is not None:

      _query_params.append(('authorization_amount_atom', authorization_amount_atom))

    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='PUT',
      resource_path='/payment-methods/{payment_method_id}/authorize',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def detach_payment_method(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PaymentMethodExternal:
    """Detach Payment Method

        Detaches a payment method from a customer.  A detached payment method can no longer be used for payment, nor can it be reattached to the same or a different customer.  A payment method cannot be detached if it is the default payment method for at least one customer, invoice, or active subscription.

        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._detach_payment_method_serialize(
      payment_method_id=payment_method_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def detach_payment_method_with_http_info(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PaymentMethodExternal]:
    """Detach Payment Method

        Detaches a payment method from a customer.  A detached payment method can no longer be used for payment, nor can it be reattached to the same or a different customer.  A payment method cannot be detached if it is the default payment method for at least one customer, invoice, or active subscription.

        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._detach_payment_method_serialize(
      payment_method_id=payment_method_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def detach_payment_method_without_preload_content(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Detach Payment Method

        Detaches a payment method from a customer.  A detached payment method can no longer be used for payment, nor can it be reattached to the same or a different customer.  A payment method cannot be detached if it is the default payment method for at least one customer, invoice, or active subscription.

        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._detach_payment_method_serialize(
      payment_method_id=payment_method_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _detach_payment_method_serialize(
    self,
    payment_method_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if payment_method_id is not None:
      _path_params['payment_method_id'] = payment_method_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/payment-methods/{payment_method_id}/detach',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_payment_method(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PaymentMethodExternal:
    """Get Payment Method


        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_payment_method_serialize(
      payment_method_id=payment_method_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_payment_method_with_http_info(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PaymentMethodExternal]:
    """Get Payment Method


        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_payment_method_serialize(
      payment_method_id=payment_method_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_payment_method_without_preload_content(
    self,
    payment_method_id: Annotated[StrictStr,
                                 Field(description='Unique Identifier of the payment_method.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Payment Method


        :param payment_method_id: Unique Identifier of the payment_method. (required)
        :type payment_method_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_payment_method_serialize(
      payment_method_id=payment_method_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PaymentMethodExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_payment_method_serialize(
    self,
    payment_method_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if payment_method_id is not None:
      _path_params['payment_method_id'] = payment_method_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/payment-methods/{payment_method_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )
