# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from typing import Any, Dict, List, Optional, Tuple, Union

from pydantic import Field, StrictFloat, StrictInt, StrictStr, validate_call

try:
  from typing import Annotated
except ImportError:
  from typing_extensions import Annotated

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.models.create_price_request import CreatePriceRequest
from getopenpay.models.delete_price_response import DeletePriceResponse
from getopenpay.models.list_response_price_external import ListResponsePriceExternal
from getopenpay.models.price_external import PriceExternal
from getopenpay.models.price_query_params import PriceQueryParams
from getopenpay.models.search_price_request import SearchPriceRequest
from getopenpay.models.update_price_request import UpdatePriceRequest
from getopenpay.rest import RESTResponseType
from pydantic import Field, StrictStr
from typing_extensions import Annotated


class PricesApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_call
  def create_price_for_product(
    self,
    create_price_request: CreatePriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PriceExternal:
    """Create Price For Product


        :param create_price_request: (required)
        :type create_price_request: CreatePriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_price_for_product_serialize(
      create_price_request=create_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def create_price_for_product_with_http_info(
    self,
    create_price_request: CreatePriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PriceExternal]:
    """Create Price For Product


        :param create_price_request: (required)
        :type create_price_request: CreatePriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_price_for_product_serialize(
      create_price_request=create_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def create_price_for_product_without_preload_content(
    self,
    create_price_request: CreatePriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Create Price For Product


        :param create_price_request: (required)
        :type create_price_request: CreatePriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_price_for_product_serialize(
      create_price_request=create_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _create_price_for_product_serialize(
    self,
    create_price_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if create_price_request is not None:
      _body_params = create_price_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/prices/',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def delete_price_for_product(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> DeletePriceResponse:
    """Delete Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_price_for_product_serialize(
      price_id=price_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'DeletePriceResponse',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def delete_price_for_product_with_http_info(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[DeletePriceResponse]:
    """Delete Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_price_for_product_serialize(
      price_id=price_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'DeletePriceResponse',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def delete_price_for_product_without_preload_content(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Delete Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._delete_price_for_product_serialize(
      price_id=price_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'DeletePriceResponse',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _delete_price_for_product_serialize(
    self,
    price_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if price_id is not None:
      _path_params['price_id'] = price_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='DELETE',
      resource_path='/prices/{price_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_price_for_product(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PriceExternal:
    """Get Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_price_for_product_serialize(
      price_id=price_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_price_for_product_with_http_info(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PriceExternal]:
    """Get Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_price_for_product_serialize(
      price_id=price_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_price_for_product_without_preload_content(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_price_for_product_serialize(
      price_id=price_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_price_for_product_serialize(
    self,
    price_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if price_id is not None:
      _path_params['price_id'] = price_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/prices/{price_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def list_prices(
    self,
    price_query_params: PriceQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ListResponsePriceExternal:
    """List Prices


        :param price_query_params: (required)
        :type price_query_params: PriceQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_prices_serialize(
      price_query_params=price_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def list_prices_with_http_info(
    self,
    price_query_params: PriceQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ListResponsePriceExternal]:
    """List Prices


        :param price_query_params: (required)
        :type price_query_params: PriceQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_prices_serialize(
      price_query_params=price_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def list_prices_without_preload_content(
    self,
    price_query_params: PriceQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """List Prices


        :param price_query_params: (required)
        :type price_query_params: PriceQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_prices_serialize(
      price_query_params=price_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _list_prices_serialize(
    self,
    price_query_params,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if price_query_params is not None:
      _body_params = price_query_params

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/prices/list',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def search_prices(
    self,
    search_price_request: SearchPriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ListResponsePriceExternal:
    """Search Prices


        :param search_price_request: (required)
        :type search_price_request: SearchPriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._search_prices_serialize(
      search_price_request=search_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def search_prices_with_http_info(
    self,
    search_price_request: SearchPriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ListResponsePriceExternal]:
    """Search Prices


        :param search_price_request: (required)
        :type search_price_request: SearchPriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._search_prices_serialize(
      search_price_request=search_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def search_prices_without_preload_content(
    self,
    search_price_request: SearchPriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Search Prices


        :param search_price_request: (required)
        :type search_price_request: SearchPriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._search_prices_serialize(
      search_price_request=search_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _search_prices_serialize(
    self,
    search_price_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if search_price_request is not None:
      _body_params = search_price_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/prices/search',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def update_price_for_product(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    update_price_request: UpdatePriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PriceExternal:
    """Update Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param update_price_request: (required)
        :type update_price_request: UpdatePriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_price_for_product_serialize(
      price_id=price_id,
      update_price_request=update_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def update_price_for_product_with_http_info(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    update_price_request: UpdatePriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PriceExternal]:
    """Update Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param update_price_request: (required)
        :type update_price_request: UpdatePriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_price_for_product_serialize(
      price_id=price_id,
      update_price_request=update_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def update_price_for_product_without_preload_content(
    self,
    price_id: Annotated[StrictStr, Field(description='Unique identifier of the price.')],
    update_price_request: UpdatePriceRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Update Price For Product


        :param price_id: Unique identifier of the price. (required)
        :type price_id: str
        :param update_price_request: (required)
        :type update_price_request: UpdatePriceRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_price_for_product_serialize(
      price_id=price_id,
      update_price_request=update_price_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PriceExternal',
      '422': 'HTTPValidationError'
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _update_price_for_product_serialize(
    self,
    price_id,
    update_price_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> Tuple:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, str] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if price_id is not None:
      _path_params['price_id'] = price_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if update_price_request is not None:
      _body_params = update_price_request

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='PUT',
      resource_path='/prices/{price_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )
