# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Union

from getopenpay.models.coupon_duration import CouponDuration
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class CouponExternal(BaseModel):
  """
    CouponExternal
    """

  # noqa: E501
  id: StrictStr
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    default=False, description='If true, indicates that this object has been deleted'
  )
  name: StrictStr
  is_active: StrictBool
  amount_atom_off: Optional[StrictInt]
  percent_off: Optional[StrictInt]
  currency: StrictStr
  duration: CouponDuration
  duration_in_months: Optional[StrictInt]
  max_redemptions: Optional[StrictInt]
  times_redeemed: Optional[StrictInt]
  redeem_by: Optional[datetime]
  products: Optional[List[StrictStr]] = None
  product_families: Optional[List[StrictStr]] = None
  promotion_codes: Optional[List[StrictStr]] = None
  metadata: Optional[Union[str, Any]] = None
  __properties: ClassVar[List[str]] = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'name', 'is_active',
    'amount_atom_off', 'percent_off', 'currency', 'duration', 'duration_in_months',
    'max_redemptions', 'times_redeemed', 'redeem_by', 'products', 'product_families',
    'promotion_codes', 'metadata'
  ]

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of CouponExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    # set to None if amount_atom_off (nullable) is None
    # and model_fields_set contains the field
    if self.amount_atom_off is None and 'amount_atom_off' in self.model_fields_set:
      _dict['amount_atom_off'] = None

    # set to None if percent_off (nullable) is None
    # and model_fields_set contains the field
    if self.percent_off is None and 'percent_off' in self.model_fields_set:
      _dict['percent_off'] = None

    # set to None if duration_in_months (nullable) is None
    # and model_fields_set contains the field
    if self.duration_in_months is None and 'duration_in_months' in self.model_fields_set:
      _dict['duration_in_months'] = None

    # set to None if max_redemptions (nullable) is None
    # and model_fields_set contains the field
    if self.max_redemptions is None and 'max_redemptions' in self.model_fields_set:
      _dict['max_redemptions'] = None

    # set to None if times_redeemed (nullable) is None
    # and model_fields_set contains the field
    if self.times_redeemed is None and 'times_redeemed' in self.model_fields_set:
      _dict['times_redeemed'] = None

    # set to None if redeem_by (nullable) is None
    # and model_fields_set contains the field
    if self.redeem_by is None and 'redeem_by' in self.model_fields_set:
      _dict['redeem_by'] = None

    # set to None if metadata (nullable) is None
    # and model_fields_set contains the field
    if self.metadata is None and 'metadata' in self.model_fields_set:
      _dict['metadata'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of CouponExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'name': obj.get('name'),
        'is_active': obj.get('is_active'),
        'amount_atom_off': obj.get('amount_atom_off'),
        'percent_off': obj.get('percent_off'),
        'currency': obj.get('currency'),
        'duration': obj.get('duration'),
        'duration_in_months': obj.get('duration_in_months'),
        'max_redemptions': obj.get('max_redemptions'),
        'times_redeemed': obj.get('times_redeemed'),
        'redeem_by': obj.get('redeem_by'),
        'products': obj.get('products'),
        'product_families': obj.get('product_families'),
        'promotion_codes': obj.get('promotion_codes'),
        'metadata': obj.get('metadata')
      }
    )
    return _obj
