# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional

from pydantic import BaseModel, Field, StrictStr

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class CreateTaxIntegrationRequest(BaseModel):
  """
    CreateTaxIntegrationRequest
    """

  # noqa: E501
  api_name: StrictStr
  api_keys: Optional[Any] = Field(
    description='These keys will allow to authenticate API requests to the tax processor.'
  )
  accounting_tz: StrictStr = Field(
    description=
    'The timezone name for the accounting timezone (see pytz.all_timezones for a full list)'
  )
  __properties: ClassVar[List[str]] = ['api_name', 'api_keys', 'accounting_tz']

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of CreateTaxIntegrationRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    # set to None if api_keys (nullable) is None
    # and model_fields_set contains the field
    if self.api_keys is None and 'api_keys' in self.model_fields_set:
      _dict['api_keys'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of CreateTaxIntegrationRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'api_name': obj.get('api_name'),
        'accounting_tz': obj.get('accounting_tz')
      }
    )
    return _obj
